﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MathTools
{
    /// <summary>
    /// Класс спроектирован для получения оценок времени 
    /// выполнения различных методов.
    /// Встроенные делегаты определяют сигнатуры этих методов
    /// </summary>
    public class TimeValue
    {
        public delegate double DToD(double arg1);

        /// <summary>
        /// Возвращает время в секундах, 
        /// затраченное на вычисление count раз
        /// метода fun с сигнатурой, удовлетворяющей 
        /// делегату DToD (double to double)
        /// </summary>
        /// <param name="count">число повторений</param>
        /// <param name="fun">имя функции</param>
        /// <param name="x">аргумент</param>
        /// <returns>время в милисекундах или тиках</returns>
        public static double EvalTimeDToD(int count, DToD fun, double x)
        {
            DateTime start, finish;
            double res = 0;
            start = DateTime.Now;
                for (int i = 1; i < count; i++)
                    fun(x);
            finish = DateTime.Now;
            //res = (finish- start).Ticks;
            res = (finish - start).Milliseconds;
            return res;

        }       
    }
}